;;; -*- TI-Asm -*-

FAIL_IF_Z macro
	ifdef ENABLE_ASSERTIONS
	 call	z, AssertionFailed
	endif
	endm

FAIL_IF_C macro
	ifdef ENABLE_ASSERTIONS
	 call	c, AssertionFailed
	endif
	endm

LOGNR macro msg, hhhh, llll, offs, len
	ifdef ENABLE_LOGGING
	 call	LogStr
	 ;; UNREACHABLE
	 db	msg
	 db	0

	 push	hl
	  push	bc
	   push	af
	    ld	a, len
	    ld	b, hhhh
	    ld	c, llll
	    ld	hl, offs
	    call LogNum
	    pop	af
	   pop	bc
	  pop	hl
	endif
	endm

LOGNUM macro msg, addr, len
	LOGNR msg, 0, 0, addr, len
	endm

TIMER_START macro
	ifdef ENABLE_TIMER
	 call	StartTimer
	endif
	endm

TIMER_STOP macro
	ifdef ENABLE_TIMER
	 push	af
	  call	StopTimer
	  ld	hl, 0
	  ld	(penCol), hl
	  ld	a, 24
	  BCALL	_DispOP1A
	  call	WaitCSC
	  pop	af
	endif
	endm
