;;; -*- TI-Asm -*-
;;;
;;; DuckSign - sign Flash applications on the TI-83 Plus
;;;
;;; Copyright (C) 2010 Benjamin Moody
;;;
;;; This program is free software: you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License as
;;; published by the Free Software Foundation; either version 3 of the
;;; License, or (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

id0104:
	db	80h, 12h, 01h, 04h

rabinP0104_length:
	db	20h
rabinP0104:
	db	5Bh, 2Eh, 54h, 0E9h, 0B5h, 0C1h, 0FEh, 26h, 0CEh, 93h, 26h
	db	14h, 78h, 0D3h, 87h, 3Fh, 3Fh, 0C4h, 1Bh, 0FFh, 0F1h, 0F5h
	db	0F9h, 34h, 0D7h, 0A5h, 79h, 3Ah, 43h, 0C1h, 0C2h, 1Ch, 0
	assert	high($) == high(rabinP0104)

P0104_INIT_BIT equ	10h

rabinQ0104_length:
	db	21h
rabinQ0104:
	db	97h, 0F7h, 70h, 7Bh, 94h, 07h, 9Bh, 73h, 85h, 87h, 20h
	db	0BFh, 6Dh, 49h, 09h, 0ABh, 3Bh, 0EDh, 0A1h, 0BAh, 9Bh, 93h
	db	11h, 2Bh, 04h, 13h, 40h, 0A1h, 6Eh, 0D5h, 97h, 0B6h, 04h
	assert	high($) == high(rabinQ0104)

Q0104_INIT_BIT equ	04h

rabinAlpha0104:
	;; pseudo-square-root of 2 mod p
	db	22h, 0B2h, 0E5h, 0D8h, 9Bh, 0A6h, 54h, 0AAh, 0E4h, 34h, 0DAh
	db	70h, 0CCh, 0EFh, 77h, 0F1h, 0FDh, 0Fh, 0F7h, 0EFh, 57h, 0E6h
	db	39h, 0FAh, 20h, 7Eh, 0B2h, 0E2h, 54h, 0F4h, 0C9h, 0Fh, 0
	assert	high($) == high(rabinAlpha0104)

rabinBeta0104:
	;; square root of 2 mod q
	db	6Ah, 0A2h, 69h, 69h, 0F7h, 3Bh, 4Ch, 9Bh, 76h, 29h, 82h
	db	0D8h, 3Ch, 61h, 97h, 5Eh, 46h, 52h, 80h, 0BBh, 6Ah, 30h
	db	0EDh, 9Dh, 43h, 0E0h, 70h, 72h, 5Ah, 0Ah, 0F1h, 6Ch, 03h
	assert	high($) == high(rabinBeta0104)

rabinPi0104:
	;; inverse of p mod q
	db	0EBh, 0Ch, 94h, 4Bh, 0F0h, 9Bh, 5Eh, 0B1h, 6Ah, 27h, 72h
	db	60h, 0E8h, 95h, 0B4h, 66h, 76h, 5Dh, 29h, 5Dh, 34h, 67h
	db	0B1h, 55h, 37h, 0C1h, 0CEh, 97h, 0DDh, 19h, 19h, 3Ah, 02h
	assert	high($) == high(rabinPi0104)
