;;; -*- TI-Asm -*-
;;;
;;; DuckSign - sign Flash applications on the TI-83 Plus
;;;
;;; Copyright (C) 2010 Benjamin Moody
;;;
;;; This program is free software: you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License as
;;; published by the Free Software Foundation; either version 3 of the
;;; License, or (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
  ifdef ENABLE_ASSERTIONS

AssertionFailed:
	BCALL	_ClrScrnFull
	ld	hl, 0
	ld	(curRow), hl
	ld	hl, AssertionFailedStr
	BCALL	_PutS
	ld	b, 4
AssertionFailed_StackLoop:
	pop	hl		; GETRETURN
	ld	a, h
	call	HexHToASCII
	BCALL	_PutC
	ld	a, h
	call	HexLToASCII
	BCALL	_PutC
	ld	a, l
	call	HexHToASCII
	BCALL	_PutC
	ld	a, l
	call	HexLToASCII
	BCALL	_PutC
	BCALL	_NewLine
	djnz	AssertionFailed_StackLoop
	call	WaitCSC
	BCALL	_ErrDimension
	;; UNREACHABLE

AssertionFailedStr:
	db "Assertion failed",0

  endif

  ifdef ENABLE_LOGGING

LogStr:
	ex	(sp), hl
	push	af
	 jr	LogStr_Begin
LogStr_Loop:
	 out	(LOG_PORT),a
LogStr_Begin:
	 ld	a, (hl)
	 inc	hl
	 or	a
	 jr	nz, LogStr_Loop
	 pop	af
	ex	(sp), hl
	ret

LogNum:
	add	hl, bc
	ld	c, a
	ld	b, 0
	add	hl, bc
	ld	b, a
LogNum_Loop:
	dec	hl
	ld	a, (hl)
	call	HexHToASCII
	out	(LOG_PORT), a
	ld	a, (hl)
	call	HexLToASCII
	out	(LOG_PORT), a
	djnz	LogNum_Loop
	ld	a, 10
	out	(LOG_PORT), a
	ret

  endif
